require 'test/unit'
require 'abload/traverse'
require 'abload/marshal_format'
require 'abload/rd_format'

require 'marshaltestlib'

class ABLoadMrshalTest < Test::Unit::TestCase
  include MarshalTestLib

  def encode(o)
    t = ABLoad::Traverser.new
    t.dump(o)
    m = ABLoad::MarshalFormatter.new
    m.dump(t.stream[0])
    m.result
  end

  def decode(s)
    Marshal.load(s)
  end
end

class ABLoadTest < Test::Unit::TestCase
  include MarshalTestLib

  def encode(o)
    t = ABLoad::Traverser.new
    t.dump(o)
    t.stream[0]
  end

  def decode(s)
    l = ABLoad::Loader.new
    l.load(s)
  end
end

class ABLoadRDTest < Test::Unit::TestCase
  include MarshalTestLib

  def encode(o)
    ABLoad::RDFormat.dump(o)
  end

  def decode(s)
    ABLoad::RDFormat.load(s)
  end
end

